// 
//  (c) Microsoft Corporation. See LICENSE.TXT file for licensing details
//  
namespace ServiceBusApp
{
    using System;

    [Serializable]
    public class ApplicationSettings
    {
        public bool NetworkProvisioningCompleted { get; set; }
        public Uri DeviceSubscriptionUri { get; set; }
        public Uri EventSubmissionUri { get; set; }
        public string DeviceAccount { get; set; }
        public string DeviceKey { get; set; }
        public double TargetTemperature { get; set; }
        public DateTime LastServerUpdate { get; set; }

        public static ApplicationSettings Defaults { get { return new ApplicationSettings {DeviceSubscriptionUri = null, DeviceAccount = null, DeviceKey = null, TargetTemperature = 20}; } }
    }
}